/***************************************************************************
                          resource.h  -  description
                             -------------------
    begin                :   18 23:09:05 EET 1999
    copyright            : (C) 1999 by Yacovlev Alexander & Dmitry Poplavsky
    email                : pdima@mail.univ.kiev.ua
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RESOURCE_H
#define RESOURCE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

///////////////////////////////////////////////////////////////////
// resource.h  -- contains macros used for commands


///////////////////////////////////////////////////////////////////
// COMMAND VALUES FOR MENUBAR AND TOOLBAR ENTRIES


///////////////////////////////////////////////////////////////////
// File-menu entries
#define ID_FILE_NEW_WINDOW          10010
#define ID_FILE_NEW                 10020
#define ID_FILE_OPEN                10030
#define ID_FILE_OPEN_RECENT         10040
#define ID_FILE_DIR_SELECT					10045
#define ID_FILE_CLOSE               10050

#define ID_FILE_SAVE                10060
#define ID_FILE_SAVE_AS             10070
#define ID_FILE_SAVE_ALL            10075

#define ID_FILE_PRINT               10080

#define ID_FILE_QUIT                10090
#define ID_FILE_LINT                10100


///////////////////////////////////////////////////////////////////
// Edit-menu entries
#define ID_EDIT_COPY                11010
#define ID_EDIT_CUT                 11020
#define ID_EDIT_PASTE               11030
#define ID_EDIT_REDO                11040
#define ID_EDIT_UNDO                11050
#define ID_EDIT_SEARCH							11060
#define ID_EDIT_SEARCH_AGAIN				11070
#define ID_EDIT_REPLACE							11080

///////////////////////////////////////////////////////////////////
// View-menu entries                    
#define ID_VIEW_TOOLBAR             12010
#define ID_VIEW_STATUSBAR           12020
#define ID_VIEW_REPAINT							12030
#define ID_VIEW_PREVIEW							12040
#define ID_VIEW_BACK								12050
#define ID_VIEW_FORWARD							12060
#define ID_VIEW_TREE								12070
#define ID_VIEW_MES 								12080
#define ID_VIEW_MIN                 12081
#define ID_VIEW_MAX                 12082
#define ID_VIEW_IN_KFM              12083


#define ID_TREE_ADDTOTOP            13010
#define ID_TREE_OPEN                13020
#define ID_TREE_CLOSE               13030
#define ID_TREE_REMOVE              13040


///////////////////////////////////////////////////////////////////
// options-menu entries
#define ID_OPTIONS_EDITOR           14010
#define ID_OPTIONS_DEFAULTS         14020


///////////////////////////////////////////////////////////////////
// Help-menu entries
#define ID_HELP_CONTENTS            1002

///////////////////////////////////////////////////////////////////
// General application values
#define ID_STATUS_MSG               1001

///////////////////////////////////////////////////////////////////
// Values for Tags toolbar
#define ID_TAG_BOLD									20001
#define ID_TAG_QUICKSTART						20002
#define ID_TAG_H1										20003
#define ID_TAG_H2                   20004
#define ID_TAG_H3                   20005
#define ID_TAG_I										20006
#define ID_TAG_U										20007
#define ID_TAG_BR										20008
#define ID_TAG_P										20009
#define ID_TAG_NBSP									20010
#define ID_TAG_DIV_LEFT   					20011
#define ID_TAG_DIV_RIGHT            20012
#define ID_TAG_DIV_CENTER           20013
#define ID_TAG_DIV_JUSTIFY          20014
#define ID_TAG_H4										20015
#define ID_TAG_H5                   20016
#define ID_TAG_FONT_INC							20017
#define ID_TAG_FONT_DEC							20018
#define ID_TAG_HR										20019
#define ID_TAG_COMM									20020
#define ID_TAG_PRE									20021
#define ID_TAG_SUB									20022
#define ID_TAG_SUP									20023
#define ID_TAG_TABLE								20024
#define ID_TAG_TH     		          20025
#define ID_TAG_TR    								20026
#define ID_TAG_TD           				20027
#define ID_TAG_CAPTION       				20028
#define ID_TAG_UL           				20029
#define ID_TAG_OL           				20030
#define ID_TAG_LI           				20031
#define ID_TAG_DL           				20032
#define ID_TAG_DT           				20033
#define ID_TAG_DD           				20034
#define ID_TAG_MENU         				20035
#define ID_TAG_MAIL         				20036
#define ID_TAG_IMAGE								20037
#define ID_TAG_A    								20038
#define ID_TAG_FONT  								20039
#define ID_TAG_FONT_BASE						20040
#define ID_TAG_QUICK_LIST						20041
#define ID_TAG_QUICK_TABLE					20042
#define ID_TAG_TABLE_ROW						20043
#define ID_TAG_TABLE_HEAD						20044
#define ID_TAG_TABLE_DATA						20045
#define ID_TAG_COLOR								20046

#define ID_TAG_TEXTAREA							20047
#define ID_TAG_RADIO								20048
#define ID_TAG_CHECK								20049
#define ID_TAG_SELECT								20050
#define ID_TAG_DATE 								20060
#define ID_TAG_FORM 								20070
#define ID_TAG_LINEEDIT							20080
#define ID_TAG_LINEPAS							20090
#define ID_TAG_SUBMIT               20100
#define ID_TAG_RESET                20110





#define IDS_STATUS_DEFAULT          "Ready."

#endif // RESOURCE_H
